function PlotPatches( patches, PatchSize, subplotH, subplotW )
%PlotPatches(patches, PatchSize, subplotH, subplotW ) 
% plots a set number of patches. Normalized per patch by
% max(abs(patch)).
% Created by Sander Keemink
% Inputs:
%   - patches:   matrix containing patches. Every column is a patch.
%   - PatchSize: patch size
%   - subplotH/W:subplot Height and Width, make sure that H*W > number of patches  
% 
%% 
figure()
for i = 1:length(patches(1,:))
    subplot(subplotH,subplotW,i)
    imshow((reshape(patches(:,i),PatchSize,PatchSize)/max(abs(patches(:,i)))+1)/2)
end

end

