%% NIP 2014 assignment 2 Example Code
%% Load images
load('ImagesTest.mat')
load('ImagesTrain.mat')
    
%% Load patches
% Set variables
PatchSize = 8; 
MiniBatchSize = 50000;

% Load patches (DC removed, flat patches removed). Note that due to flat
% patch removal, you might have less patches than MiniBatchSize.
patchTrain = RandPatchesFromImagesCell(MiniBatchSize,PatchSize,imTrain);
patchTest = RandPatchesFromImagesCell(MiniBatchSize,PatchSize,imTest);

%% plot 50 example patches
% plots as many patches as you give it, within the subplot windows. See
% function help for more info. 
PlotPatches(patchTrain(:,1:50),PatchSize,10,5)

%% do ICA  (can take a while)
[W,A] = ica_nis( patchTrain );
% NIP students -- you don't need to run this, use precomputed ICA model

%% How to estimate the MoG's a la Z&W
% Set variables
nmodels = 200; % number of Gaussians

% Learn a new model (takes a while)
NewGMM = OnlineGMMEM(nmodels,@(N) removeDC(RandPatchesFromImagesCell(N,PatchSize,imTrain)),1000,MiniBatchSize,filename);
% NIP students -- you don't need to run this, use precomputed GMM model

%% Calculate the likelihood for MoG
% calculate log likelihood 
[l,ll] = GMMLogL(patchTest,GMM);

% l is the logL per patch.
% ll is the logL per patch per component