function [ Wica Aica ] = ica_nis( X )
%ICA_NIS Does ICA according to the method in Natural Image Statistics.
%  This code is directly based on there code in 'figures.m', which can be
%  found on their website: http://www.naturalimagestatistics.net/
%   Model:
%       s = Ax
%       x = Ws
%       A = W^-1
%   Inputs:
%       - X: patches matrix
%   Outputs:
%       - W,A: receptive/projective matrices
%   Example:
%       - [ W A] = ica_nis( X )
%%
%Sample data and preprocess
n = length(X(:,1)); % number of pixels

% Do PCA and whiten data
[V,E,D]=pca_nis(X);
Z=V*X;

% do the ica
W=ica(Z,n); 
%transform back to original space from whitened space
Wica = W*V;
%Compute A using pseudoinverse (inverting canonical preprocessing is tricky)
Aica=pinv(Wica);


end

